--  Copyright (C) 2005  Adrian Knoth <adi@thur.de>

--  This program is free software; you can redistribute it and/or
--  modify it under the terms of the GNU General Public License
--  as published by the Free Software Foundation; either version 2
--  of the License, or (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

with Ada.Text_IO;

package body ao is

   procedure aao_play (device : ao_device_ptr; buffer : stereo_buffer_ptr;
                       lastone : Positive)
   is
      samplecount : constant Interfaces.C.Extensions.Unsigned_32 :=
                    Unsigned_32 (lastone * (buffer'Component_Size / 8));
      returncode : int;
      buf_ptr_chr : chars_ptr;
      for buf_ptr_chr'Address use buffer'Address;
   begin
      returncode := ao_play (device, buf_ptr_chr, samplecount);
   end aao_play;

   procedure aao_play (device : ao_device_ptr; buffer : stereo_buffer_ptr)
   is
      samplecount : constant Integer := (buffer'Last - buffer'First + 1);
   begin
      aao_play (device, buffer, samplecount);
   end aao_play;

   --  Close a device, neglect returncode
   procedure aao_close (device : ao_device_ptr)
   is
      returncode : int := ao_close (device);
   begin
      null;
   end aao_close;

   function aao_is_big_endian return Boolean
   is
      returncode : constant int := ao_is_big_endian;
   begin
      return (returncode /= 0);
   end aao_is_big_endian;

end ao;