--  Copyright (C) 2005  Adrian Knoth <adi@thur.de>

--  This program is free software; you can redistribute it and/or
--  modify it under the terms of the GNU General Public License
--  as published by the Free Software Foundation; either version 2
--  of the License, or (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

--  ----------------------------------------------------------------------
--  **********************************************************************
--  *                                                                    *
--  *  compile:  gnatmake ao_example.adb -largs -lao                     *
--  *                                                                    *
--  *  Note: exceptions not handled for file_not_found or similar        *
--  *        errors                                                      *
--  **********************************************************************
--  ----------------------------------------------------------------------

with ao; use ao;
--  with Interfaces.C.Strings; use Interfaces.C.Strings;
--  with Interfaces.C.Extensions; use Interfaces.C.Extensions;
--  with Interfaces.C; use Interfaces.C;
--  with Ada.Text_IO; use Ada.Text_IO;
--  with System.Address_Image;
--  with Unchecked_Conversion;
--  with Ada.Command_Line;
with Ada.Sequential_IO;


procedure ao_example is

   package myio is new Ada.Sequential_IO (stereo_sample);
   use myio;

   File : myio.File_Type;
   --  letzter : Interfaces.C.Extensions.Unsigned_32;
   --  fehler : int;
   lastone : Integer;
   default_driver : driver;
   --  device : aliased ao_device;
   device_ptr : ao_device_ptr; -- := device'unchecked_access;
   format : ao_sample_fmt := new ao_sample_format;

   buffer : stereo_buffer_ptr := new stereo_buffer (1 .. 30000);
   --  buf_ptr_chr : chars_ptr;
   --  for buf_ptr_chr'Address use buffer'Address;


--   function To_Sys is
--        new Unchecked_Conversion (chars_ptr, System.Address);

begin
   myio.Open (File => File, Name => "musi.raw",
                           Mode =>    In_File);
   Reset (File);
   ao_initialize;
   --  format.byte_format := AO_Fmt_Little;
   default_driver := ao_default_driver_id;
   device_ptr := ao_open_live (default_driver, format, null);

--   Ada.Text_IO.Put_Line ("Stack-pointer for audio-buffer at " &
--                          System.Address_Image (buffer'Address) &
--                         " pointing to heap-area at " &
--                          System.Address_Image (To_Sys (buf_ptr_chr)));

   while not End_Of_File (File) loop
      declare
      begin
         for i in buffer'Range loop
            lastone := i;
            Read (File, buffer (i));
         end loop;
      exception
         when myio.End_Error => null;
      end;

      --  letzter := Unsigned_32 (buffer'Last - buffer'First + 1) *
      --           buffer'Component_Size/8;
      --   fehler := ao_play (device_ptr, buf_ptr_chr, letzter);

      aao_play (device_ptr, buffer, lastone);
      --  aao_play (device_ptr, buffer);

   end loop;
   myio.Close (File);
   --  fehler := ao_close (device_ptr);
   aao_close (device_ptr);
   ao_shutdown;
end ao_example;
